/*
 * File         : SAP.h
 * Author       : Pawel Roman
 * Created      : Tue Aug 26 14:40:10 1997
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#if !defined( __SAP_H )
#define __SAP_H

#if defined( _WIN32 )
#if !defined( _WINSOCKAPI_ )
#include <winsock.h>
#endif
#if defined( DLL_BUILDING )
#define DLL_EXPORT __declspec( dllexport )
#else
#define DLL_EXPORT __declspec( dllimport )
#endif
#else
#include <stdio.h>
#include <unistd.h>
#define DLL_EXPORT
#endif

class DLL_EXPORT SAP
{
public:
#if defined( _WIN32 )
 	typedef SOCKET SAP_HANDLE;
#else
	typedef int SAP_HANDLE;
#endif

	SAP() : handle_( -1 ) {}
	int init();
	int open( int port, const char* host );
	int open( int port );
	int accept( SAP& );
	int close();
	int recv_n( void* buffer, size_t len ) const;
    int recv_n( void* buffer, size_t len, int flags, timeval* tv ) const;
    int send_n( void* buffer, size_t len ) const;
	unsigned long avail() const;
	int status() const;
    SAP_HANDLE get_handle() const { return handle_; }
    void set_handle( SAP_HANDLE h ) { handle_ = h; }
      
protected:
	SAP_HANDLE handle_;
};

#endif

